<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="pt"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>UserService.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Credenciamento</a> &gt; <a href="index.source.html" class="el_package">br.edu.unifacisa.lti.service</a> &gt; <span class="el_source">UserService.java</span></div><h1>UserService.java</h1><pre class="source lang-java linenums">package br.edu.unifacisa.lti.service;

import java.time.ZonedDateTime;
import java.util.HashSet;
import java.util.List;
import java.util.Optional;
import java.util.Set;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.security.crypto.password.PasswordEncoder;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import br.edu.unifacisa.lti.config.Constants;
import br.edu.unifacisa.lti.domain.Authority;
import br.edu.unifacisa.lti.domain.User;
import br.edu.unifacisa.lti.repository.AuthorityRepository;
import br.edu.unifacisa.lti.repository.UserRepository;
import br.edu.unifacisa.lti.security.AuthoritiesConstants;
import br.edu.unifacisa.lti.security.SecurityUtils;
import br.edu.unifacisa.lti.service.dto.UserDTO;
import br.edu.unifacisa.lti.service.util.RandomUtil;



/**
 * Service class for managing users.
 */
@Service
@Transactional
public class UserService {

<span class="fc" id="L37">    private final Logger log = LoggerFactory.getLogger(UserService.class);</span>

    private final UserRepository userRepository;

    private final PasswordEncoder passwordEncoder;

    private final AuthorityRepository authorityRepository;

<span class="fc" id="L45">    public UserService(UserRepository userRepository, PasswordEncoder passwordEncoder, AuthorityRepository authorityRepository) {</span>
<span class="fc" id="L46">        this.userRepository = userRepository;</span>
<span class="fc" id="L47">        this.passwordEncoder = passwordEncoder;</span>
<span class="fc" id="L48">        this.authorityRepository = authorityRepository;</span>
<span class="fc" id="L49">    }</span>

    public Optional&lt;User&gt; activateRegistration(String key) {
<span class="nc" id="L52">        log.debug(&quot;Activating user for activation key {}&quot;, key);</span>
<span class="nc" id="L53">        return userRepository.findOneByActivationKey(key)</span>
<span class="nc" id="L54">            .map(user -&gt; {</span>
                // activate given user for the registration key.
<span class="nc" id="L56">                user.setActivated(true);</span>
<span class="nc" id="L57">                user.setActivationKey(null);</span>
<span class="nc" id="L58">                log.debug(&quot;Activated user: {}&quot;, user);</span>
<span class="nc" id="L59">                return user;</span>
            });
    }

    public Optional&lt;User&gt; completePasswordReset(String newPassword, String key) {
<span class="fc" id="L64">       log.debug(&quot;Reset user password for reset key {}&quot;, key);</span>

<span class="fc" id="L66">       return userRepository.findOneByResetKey(key)</span>
<span class="fc" id="L67">            .filter(user -&gt; {</span>
<span class="fc" id="L68">                ZonedDateTime oneDayAgo = ZonedDateTime.now().minusHours(24);</span>
<span class="fc" id="L69">                return user.getResetDate().isAfter(oneDayAgo);</span>
           })
<span class="fc" id="L71">           .map(user -&gt; {</span>
<span class="fc" id="L72">                user.setPassword(passwordEncoder.encode(newPassword));</span>
<span class="fc" id="L73">                user.setResetKey(null);</span>
<span class="fc" id="L74">                user.setResetDate(null);</span>
<span class="fc" id="L75">                return user;</span>
           });
    }

    public Optional&lt;User&gt; requestPasswordReset(String mail) {
<span class="fc" id="L80">        return userRepository.findOneByEmail(mail)</span>
<span class="fc" id="L81">            .filter(User::getActivated)</span>
<span class="fc" id="L82">            .map(user -&gt; {</span>
<span class="fc" id="L83">                user.setResetKey(RandomUtil.generateResetKey());</span>
<span class="fc" id="L84">                user.setResetDate(ZonedDateTime.now());</span>
<span class="fc" id="L85">                return user;</span>
            });
    }

    public User createUser(String login, String password, String firstName, String lastName, String email,
        String imageUrl, String langKey) {

<span class="fc" id="L92">        User newUser = new User();</span>
<span class="fc" id="L93">        Authority authority = authorityRepository.findOne(AuthoritiesConstants.USER);</span>
<span class="fc" id="L94">        Set&lt;Authority&gt; authorities = new HashSet&lt;&gt;();</span>
<span class="fc" id="L95">        String encryptedPassword = passwordEncoder.encode(password);</span>
<span class="fc" id="L96">        newUser.setLogin(login);</span>
        // new user gets initially a generated password
<span class="fc" id="L98">        newUser.setPassword(encryptedPassword);</span>
<span class="fc" id="L99">        newUser.setFirstName(firstName);</span>
<span class="fc" id="L100">        newUser.setLastName(lastName);</span>
<span class="fc" id="L101">        newUser.setEmail(email);</span>
<span class="fc" id="L102">        newUser.setImageUrl(imageUrl);</span>
<span class="fc" id="L103">        newUser.setLangKey(langKey);</span>
        // new user is not active
<span class="fc" id="L105">        newUser.setActivated(true);</span>
        // new user gets registration key
<span class="fc" id="L107">        newUser.setActivationKey(RandomUtil.generateActivationKey());</span>
<span class="fc" id="L108">        authorities.add(authority);</span>
<span class="fc" id="L109">        newUser.setAuthorities(authorities);</span>
<span class="fc" id="L110">        userRepository.save(newUser);</span>
<span class="fc" id="L111">        log.debug(&quot;Created Information for User: {}&quot;, newUser);</span>
<span class="fc" id="L112">        return newUser;</span>
    }

    public User createUser(UserDTO userDTO) {
<span class="fc" id="L116">        User user = new User();</span>
<span class="fc" id="L117">        user.setLogin(userDTO.getLogin());</span>
<span class="fc" id="L118">        user.setFirstName(userDTO.getFirstName());</span>
<span class="fc" id="L119">        user.setLastName(userDTO.getLastName());</span>
<span class="fc" id="L120">        user.setEmail(userDTO.getEmail());</span>
<span class="fc" id="L121">        user.setImageUrl(userDTO.getImageUrl());</span>
<span class="pc bpc" id="L122" title="1 of 2 branches missed.">        if (userDTO.getLangKey() == null) {</span>
<span class="nc" id="L123">            user.setLangKey(&quot;pt-br&quot;); // default language</span>
        } else {
<span class="fc" id="L125">            user.setLangKey(userDTO.getLangKey());</span>
        }
<span class="pc bpc" id="L127" title="1 of 2 branches missed.">        if (userDTO.getAuthorities() != null) {</span>
<span class="fc" id="L128">            Set&lt;Authority&gt; authorities = new HashSet&lt;&gt;();</span>
<span class="fc" id="L129">            userDTO.getAuthorities().forEach(</span>
<span class="fc" id="L130">                authority -&gt; authorities.add(authorityRepository.findOne(authority))</span>
            );
<span class="fc" id="L132">            user.setAuthorities(authorities);</span>
        }
<span class="fc" id="L134">        String encryptedPassword = passwordEncoder.encode(RandomUtil.generatePassword());</span>
<span class="fc" id="L135">        user.setPassword(encryptedPassword);</span>
<span class="fc" id="L136">        user.setResetKey(RandomUtil.generateResetKey());</span>
<span class="fc" id="L137">        user.setResetDate(ZonedDateTime.now());</span>
<span class="fc" id="L138">        user.setActivated(true);</span>
<span class="fc" id="L139">        userRepository.save(user);</span>
<span class="fc" id="L140">        log.debug(&quot;Created Information for User: {}&quot;, user);</span>
<span class="fc" id="L141">        return user;</span>
    }

    /**
     * Update basic information (first name, last name, email, language) for the current user.
     *
     * @param firstName first name of user
     * @param lastName last name of user
     * @param email email id of user
     * @param langKey language key
     * @param imageUrl image URL of user
     */
    public void updateUser(String firstName, String lastName, String email, String langKey, String imageUrl) {
<span class="nc" id="L154">        userRepository.findOneByLogin(SecurityUtils.getCurrentUserLogin()).ifPresent(user -&gt; {</span>
<span class="nc" id="L155">            user.setFirstName(firstName);</span>
<span class="nc" id="L156">            user.setLastName(lastName);</span>
<span class="nc" id="L157">            user.setEmail(email);</span>
<span class="nc" id="L158">            user.setLangKey(langKey);</span>
<span class="nc" id="L159">            user.setImageUrl(imageUrl);</span>
<span class="nc" id="L160">            log.debug(&quot;Changed Information for User: {}&quot;, user);</span>
<span class="nc" id="L161">        });</span>
<span class="nc" id="L162">    }</span>

    /**
     * Update all information for a specific user, and return the modified user.
     *
     * @param userDTO user to update
     * @return updated user
     */
    public Optional&lt;UserDTO&gt; updateUser(UserDTO userDTO) {
<span class="fc" id="L171">        return Optional.of(userRepository</span>
<span class="fc" id="L172">            .findOne(userDTO.getId()))</span>
<span class="fc" id="L173">            .map(user -&gt; {</span>
<span class="fc" id="L174">                user.setLogin(userDTO.getLogin());</span>
<span class="fc" id="L175">                user.setFirstName(userDTO.getFirstName());</span>
<span class="fc" id="L176">                user.setLastName(userDTO.getLastName());</span>
<span class="fc" id="L177">                user.setEmail(userDTO.getEmail());</span>
<span class="fc" id="L178">                user.setImageUrl(userDTO.getImageUrl());</span>
<span class="fc" id="L179">                user.setActivated(userDTO.isActivated());</span>
<span class="fc" id="L180">                user.setLangKey(userDTO.getLangKey());</span>
<span class="fc" id="L181">                Set&lt;Authority&gt; managedAuthorities = user.getAuthorities();</span>
<span class="fc" id="L182">                managedAuthorities.clear();</span>
<span class="fc" id="L183">                userDTO.getAuthorities().stream()</span>
<span class="fc" id="L184">                    .map(authorityRepository::findOne)</span>
<span class="fc" id="L185">                    .forEach(managedAuthorities::add);</span>
<span class="fc" id="L186">                log.debug(&quot;Changed Information for User: {}&quot;, user);</span>
<span class="fc" id="L187">                return user;</span>
            })
<span class="fc" id="L189">            .map(UserDTO::new);</span>
    }

    public void deleteUser(String login) {
<span class="fc" id="L193">        userRepository.findOneByLogin(login).ifPresent(user -&gt; {</span>
<span class="fc" id="L194">            userRepository.delete(user);</span>
<span class="fc" id="L195">            log.debug(&quot;Deleted User: {}&quot;, user);</span>
<span class="fc" id="L196">        });</span>
<span class="fc" id="L197">    }</span>

    public void changePassword(String password) {
<span class="nc" id="L200">        userRepository.findOneByLogin(SecurityUtils.getCurrentUserLogin()).ifPresent(user -&gt; {</span>
<span class="nc" id="L201">            String encryptedPassword = passwordEncoder.encode(password);</span>
<span class="nc" id="L202">            user.setPassword(encryptedPassword);</span>
<span class="nc" id="L203">            log.debug(&quot;Changed password for User: {}&quot;, user);</span>
<span class="nc" id="L204">        });</span>
<span class="nc" id="L205">    }</span>

    @Transactional(readOnly = true)
    public Page&lt;UserDTO&gt; getAllManagedUsers(Pageable pageable) {
<span class="fc" id="L209">        return userRepository.findAllByLoginNot(pageable, Constants.ANONYMOUS_USER).map(UserDTO::new);</span>
    }

    @Transactional(readOnly = true)
    public Optional&lt;User&gt; getUserWithAuthoritiesByLogin(String login) {
<span class="fc" id="L214">        return userRepository.findOneWithAuthoritiesByLogin(login);</span>
    }

    @Transactional(readOnly = true)
    public User getUserWithAuthorities(Long id) {
<span class="nc" id="L219">        return userRepository.findOneWithAuthoritiesById(id);</span>
    }

    @Transactional(readOnly = true)
    public User getUserWithAuthorities() {
<span class="nc" id="L224">        return userRepository.findOneWithAuthoritiesByLogin(SecurityUtils.getCurrentUserLogin()).orElse(null);</span>
    }


    /**
     * Not activated users should be automatically deleted after 3 days.
     * &lt;p&gt;
     * This is scheduled to get fired everyday, at 01:00 (am).
     * &lt;/p&gt;
     */
    @Scheduled(cron = &quot;0 0 1 * * ?&quot;)
    public void removeNotActivatedUsers() {
<span class="fc" id="L236">        ZonedDateTime now = ZonedDateTime.now();</span>
<span class="fc" id="L237">        List&lt;User&gt; users = userRepository.findAllByActivatedIsFalseAndCreatedDateBefore(now.minusDays(3));</span>
<span class="pc bpc" id="L238" title="1 of 2 branches missed.">        for (User user : users) {</span>
<span class="nc" id="L239">            log.debug(&quot;Deleting not activated user {}&quot;, user.getLogin());</span>
<span class="nc" id="L240">            userRepository.delete(user);</span>
<span class="nc" id="L241">        }</span>
<span class="fc" id="L242">    }</span>
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.jacoco.org/jacoco">JaCoCo</a> 0.7.9.201702052155</span></div></body></html>